//+------------------------------------------------------------------+
//|                                          MTF_RSI_sound_alert.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112 & Oxy"
#property link      "http://www.forex-tsd.com & http://oxy.opentraders.ru/bio/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 20
#property indicator_level2 80
#property indicator_minimum 0
#property indicator_maximum 100

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/
extern int TimeFrame=1;
extern int RSIperiod=5;
extern int applied_price=0;

int Del = 5;
int delTime = 300;
datetime _Time_C_L1;
datetime _Time_C_L2;
bool upLevel1=false;
bool upLevel2=false;
bool dnLevel1=false;
bool dnLevel2=false;
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("MTF_RSI("+RSIperiod+") ("+TimeFrameStr+")");
   
   _Time_C_L1=TimeCurrent();
   _Time_C_L2=TimeCurrent();
   
      return(0);
  }
//----
   
 
//+------------------------------------------------------------------+
//| MTF RSI                                            |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
   ExtMapBuffer1[i]=iRSI(NULL,TimeFrame,RSIperiod,applied_price,y) ; 
   
   } 
   
   
   //______________________________________________________   
   // level1 - 30; level2 - 70
   if(ExtMapBuffer1[0]>indicator_level2)     upLevel2=true;
   if(ExtMapBuffer1[0]>indicator_level1)     upLevel1=true;
   if(ExtMapBuffer1[0]<indicator_level2-Del) dnLevel2=true;
   if(ExtMapBuffer1[0]<indicator_level1-Del) dnLevel1=true;
   
   if(ExtMapBuffer1[0]>=indicator_level1-Del && ExtMapBuffer1[0]<=indicator_level1){
     if(upLevel1 || dnLevel1) {
       upLevel1=false;
       dnLevel1=false;
       //  ,   5 
       if(TimeCurrent()>_Time_C_L1+delTime) {
         _Time_C_L1=TimeCurrent();
         Alert(Symbol(), "  = ", indicator_level1);
         PlaySound("alert.wav");
       }       
     }     
   }
   if(ExtMapBuffer1[0]>=indicator_level2-Del && ExtMapBuffer1[0]<=indicator_level2){
     if(upLevel2 || dnLevel2) {
       upLevel2=false;
       dnLevel2=false;
       //  ,   5 
       if(TimeCurrent()>_Time_C_L2+delTime) {
         _Time_C_L2=TimeCurrent();
         Alert(Symbol(), "  = ", indicator_level2);
         PlaySound("alert.wav");
       }       
     }     
   }
   //______________________________________________________
   
   return(0);
  }
//+------------------------------------------------------------------+